#!/usr/bin/env python
# coding=utf-8

import threading
import sys
import string
import subprocess
import base64
import gobject
import re
from tools import RunExternalApp

class PluginLaunchbutton:
	''' A standard launcher plugin.
	
	'''
	def __init__(self, name, command):
		''' Initialise the plugin.
		
		__name is the string that will be displayed on the launch-button.
		it should always be in brackets with a leading underline to be
		translatable. You may call this attribute other than __name 
		or even generate it from a function, as long as
		you provide the proper string through the "get_name" method.
	
		'''
		self.__name = name
		self.__command = command
		self.show_button = True # Show the launch button for this plugin by default
		self.show_edit_combo = True # Show the entry in the editors combobox-default-app for this plugin by default		
		
	def launch(self, url):
		''' This method is mandatory for all launcher plugins. 
		it has always to receive the url as 2. argument.
		
		Return	boolean True | False (mandatory!)
		
		'''
		if url == '':
			return False
		launch = RunExternalApp(self.__command, url)
		launch.start()
		return True
	
	def get_name(self):
		''' This method is mandatory for all launcher plugins. 
		it has always to return the Name to be shown on the button as 
		translatable string (see above in __init__). The name has also to be unique 
		within to all installed plugins!!!
		'''
		return self.__name
	
	
	
