#!/usr/bin/env python
# coding=utf-8

import sys
mswindows = (sys.platform == "win32")
#mswindows = False
try:
	import pygtk
	pygtk.require("2.0")
except:
	print "pygtk 2.0 is not installed"
  
try:
	import gtk
	import gtk.glade
	#import _gtk
except:
	print "gtk and/or glade is not installed - exiting..."
	#log.error("gtk and/or glade is not installed - exiting...")
	sys.exit(1)

import gettext
import gobject
import locale
import pango
import base64
from tempfile import NamedTemporaryFile, mkstemp, mkdtemp
import os
from copy import copy
import re
import string
import time
import xml.etree.ElementTree as ET
import webmarx
import settings
from bookmarks import Bookmarkhelper
import tools
from tools import Autoconnect, GTK_tools, DelayedAction, RunExternalApp
from StaticPlugins import PluginLaunchbutton
import Dialogs
from plugins import launchDefaultapp

tooltips = gtk.Tooltips()

class Window(gobject.GObject):
	''' The main gui. '''
	def __init__(self, app=None):
		gobject.GObject.__init__(self)
		self._app = app
		self.gladefile = self._app.Settings.libdir + "/Webmarks.glade"
		self.Autoconnect = Autoconnect(self)
		self.autoconnect = self.Autoconnect.autoconnect
		self.disconnect = self.Autoconnect.disconnect
		self.BookmarkExpander = None
		self.visibleItems = []
		self.selected_bookmark_backup = None
		self.launcher_menuitems = []

	def __initLauncherPlugins(self):
		self.launcher_menuitems = []
		for child in self.vboxLauncher:
			self.vboxLauncher.remove(child)
		for child in self.vboxLauncherApps:
			self.vboxLauncherApps.remove(child)			
		for item in self.launcher_menuitems:
			self.menuPopupBookmarks.remove(item)
		sep = gtk.SeparatorMenuItem()
		self.menuPopupBookmarks.append(sep)
		sep.show()		
		pplugins = []
		LPlugins = self._app.launcherPlugins
		for lplugin in LPlugins:
			file = None
			button = None
			pname = lplugin.get_name()			
			button = gtk.Button(label=pname)
			try:
				if lplugin.get_tooltip() != None:
					tooltips.set_tip(button, lplugin.get_tooltip())
				button.launcher = lplugin.launch
				button.set_name(pname)
				button.connect('clicked', self.on_LaunchButton_clicked)
				pplugins.append((pname, lplugin))
				self.vboxLauncher.pack_start(button, expand=False, fill=True, padding=2)
				
				menu_item = gtk.MenuItem(pname)
				menu_item.launcher = lplugin.launch
				menu_item.connect('activate', self.on_menuitemLaunch_activate)
				self.launcher_menuitems.append(menu_item)
				self.menuPopupBookmarks.append(menu_item)
			except:
				pass
		launchers = self._app.Settings.launchers
		for name, command in launchers:
			button = gtk.Button(label=name)
			button.launcher = command
			button.set_name(name)
			button.connect('clicked', self.on_LaunchButtonExtra_clicked)
			self.vboxLauncherApps.pack_start(button, expand=False, fill=True, padding=2)
			plugin = PluginLaunchbutton(name, command)
			pplugins.append((name, plugin))	
			
			menu_item = gtk.MenuItem(name)
			menu_item.launcher = command
			menu_item.connect('activate', self.on_menuitemLaunchExtra_activate)
			self.launcher_menuitems.append(menu_item)
			self.menuPopupBookmarks.append(menu_item)
									
		self.vboxLauncherApps.show_all()			
		appmodel = self.__create_model_comboboxEditApp(pplugins)
		self.comboboxEditApp.set_model(appmodel)
		self.vboxLauncher.show_all()
		return None
	
	def on_LaunchButton_clicked(self, widget, *event):
		if self._app.selected_bookmark != None:
			if self._app.selected_bookmark.get('url'):
				launch = widget.launcher(self._app.selected_bookmark.get('url'))
			if self._app.Settings.close_on_launch == True:
				self.close()	
	
	def on_LaunchButtonExtra_clicked(self, widget, *event):
		if self._app.selected_bookmark != None:
			if self._app.selected_bookmark.get('url'):
				launch = RunExternalApp(widget.launcher, self._app.selected_bookmark.get('url'))
				launch.start()
				if self._app.Settings.close_on_launch == True:
					self.close()
					
	def on_menuitemLaunch_activate(self, widget, *event):
		if self._app.selected_bookmark != None:
			if self._app.selected_bookmark.get('url'):
				launch = widget.launcher(self._app.selected_bookmark.get('url'))
			if self._app.Settings.close_on_launch == True:
				self.close()
				
	def on_menuitemLaunchExtra_activate(self, widget, *event):
		if self._app.selected_bookmark != None:
			if self._app.selected_bookmark.get('url'):
				launch = RunExternalApp(widget.launcher, self._app.selected_bookmark.get('url'))
				launch.start()
				if self._app.Settings.close_on_launch == True:
					self.close()
					
	def show_menuitemsLaunch(self, showitems=True):
		for item in self.launcher_menuitems:
			if showitems == True:
				item.show()
			else:
				item.hide()
	
	def refresh_settings(self):
		self.refresh_bookmarks()
		#gobject.idle_add(self.__initLauncherPlugins, self._app.launcherPlugins)
		self.__initLauncherPlugins()
		
	def refresh_bookmarks(self):
		gobject.idle_add(self.__reload_treeviewBookmarks)
		gobject.idle_add(self.__reload_comboboxEditParent)
		gobject.idle_add(self._app.Tray.reset_menu)

	def __create_model_comboboxEditApp(self, data):
		store = gtk.TreeStore(gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_PYOBJECT)
		if data != None:
			id = 0
			iters = {}
			for name, plugin in data:
				iter = store.append(None, row=(plugin.get_name(), name, plugin))
		return store		 
	
	def backup_warning(self):
		damaged_filename = str(self._app.Settings['webmarkfile']) + '-damaged'
		title = 'Warning: Loading bookmarks failed!'
		text = '<b>%s</b>' % _('The bookmarks file has been corrupted for any reason\n\
during the last session!\n\n\
All bookmarks has been restored from the \n\
backup which was made last time you saved them.\n\n')
		text += _('A copy of the corrupted file has been made here:\n%s\n\
If you want to know what\'s happened, you might been interested to examine it.\n\
Otherwise there is no risk in deleting the file.') % damaged_filename
		diag = Dialogs.DialogWarning(text, title)

	def Show(self):
		''' Initializes the GUI and assigns all initial parameters to the widgets on startup '''
		self.wTree = gtk.glade.XML(self.gladefile, "mainwindow", webmarx.APP)
		for widget in self.wTree.get_widget_prefix(''):
			wname = widget.get_name()
			setattr(self, str(wname), widget)
				
		self.BookmarkExpander = BookmarkExpander(self._app, self.treeviewBookmarks)
		icon = os.path.join(self._app.Settings.pixmapdir, 'trayicon.png')
		self.mainwindow.set_icon_from_file(icon)

		wtree = gtk.glade.XML(self.gladefile,"menuPopupTags", webmarx.APP)
		self.menuPopupTags = wtree.get_widget("menuPopupTags")
		self.menuitemDeleteTag = wtree.get_widget("menuitemDeleteTag")
		self.menuitemDeleteTag.connect('activate', self.on_menuitemDeleteTag_activate)
		
		wtree = gtk.glade.XML(self.gladefile,"menuPopupMarktags", webmarx.APP)
		self.menuPopupMarktags = wtree.get_widget("menuPopupMarktags")
		self.menuitemRemoveTag = wtree.get_widget("menuitemRemoveTag")
		self.menuitemRemoveTag.connect('activate', self.on_menuitemRemoveTag_activate)
		
		wtree = gtk.glade.XML(self.gladefile,"menuPopupBookmarks", webmarx.APP)
		self.menuPopupBookmarks = wtree.get_widget("menuPopupBookmarks")
		self.menuitemAddBookmark = wtree.get_widget("menuitemAddBookmark")
		self.menuitemAddBookmark.connect('activate', self.on_menuitemAddBookmark_activate)
		
		self.menuitemAddDir = wtree.get_widget("menuitemAddDir")
		self.menuitemAddDir.connect('activate', self.on_menuitemAddDir_activate)
		
		self.menuitemDeleteBookmark = wtree.get_widget("menuitemDeleteBookmark")
		self.menuitemDeleteBookmark.connect('activate', self.on_menuitemDeleteBookmark_activate)

		self.menuitemOrderTree = wtree.get_widget("menuitemOrderTree")
		self.menuitemOrderTree.connect('activate', self.on_menuitemOrderTree_activate)		
		
		self.tableTagfilter = TagTable(self._app)
		self.eventboxTagfilter.add(self.tableTagfilter)
		tcolor = gtk.gdk.color_parse('#FFFFFF')
		self.eventboxTagfilter.modify_bg(gtk.STATE_NORMAL, tcolor)		 
		self.eventboxTagfilter.show_all()
		targets = [('STRING', 0, 0),('STRING', 0, 1)]				
		self.tableTagfilter.show_all()
		self.tableTagfilter.connect('drag_drop', self.on_tableTagfilter_drag_drop)
		
		self.tableTagfilter.connect('drag_motion', self.on_tableTagfilter_drag_motion)
		self.expanderTags.connect("notify::expanded", self.on_expanderTags_expanded)
		self.expanderProperties.connect('notify::expanded', self.on_expanderProperties_expanded)

		hcolor = gtk.gdk.color_parse('#D8EBFF')
		self.eventboxOverviewHead.modify_bg(gtk.STATE_NORMAL, hcolor)		
		ncolor = gtk.gdk.color_parse('#FFFFFF')
		self.eventboxOverviewBody.modify_bg(gtk.STATE_NORMAL, ncolor)
		fcolor = gtk.gdk.color_parse('#FFFFFF')
		self.eventboxOverviewFooter.modify_bg(gtk.STATE_NORMAL, fcolor)
		
		if self._app.launcherPlugins:
			self.__initLauncherPlugins()
		if self._app.exportPlugins:
			self.__initExportPlugins(self._app.exportPlugins)		
		
		self.__init_comboboxEditParent()
		self.__init_treeviewTaglist()
		self.__init_treeviewElementTaglist()
		self.autoconnect()
		self.__init_treeviewBookmarks()
		self.expanderProperties.set_expanded(True)
		self.expanderTags.set_expanded(True)
		self.mainwindow.set_default_size(1, self.mainwindow.size_request()[1])
		self.mainwindow.present()
		if self._app.backup_warning == True:
			self.backup_warning()
		
	def on_toolbuttonCompactView_toggled(self, widgt):
		''' Toggle between compact and full view '''	
		
		self.toggle_compact(self.toolbuttonCompactView.get_active())
		
	def toggle_compact(self, compact=False):
		''' Toggle between compact and full view
		
		compact		-- Boolean True | False, if True, the compact-view will be shown.
		
		'''
		label = _('Compact view')
		homogeneous = True
		if compact:
			homogeneous = False
			label = ''
			self.frameTagfilter.hide()			
			self.expanderProperties.hide()
			self.expanderTags.hide()
			self.toolbuttonShowSettings.hide()
			self.toolbuttonExit.hide()
			self.toolbuttonInfo.hide()
			self.mainwindow.resize(1, self.mainwindow.get_default_size()[1])
			self.hpanedMain.set_position(-1)
		else:
			self.frameTagfilter.show()
			self.expanderProperties.show_all()
			self.expanderTags.show_all()
			self.toolbuttonShowSettings.show_all()
			self.toolbuttonExit.show_all()
			self.toolbuttonInfo.show_all()
			self.mainwindow.set_default_size(1, self.mainwindow.size_request()[1])
		self.labelToolbuttonCompactView.set_text(label)
		self.hboxBookmarsgroup.set_homogeneous(homogeneous)

	def on_expanderProperties_expanded(self, widgt, *args):
		''' Toggle between compact and full view '''	
		if self.expanderProperties.get_expanded() == True:
			self.labelProperties.set_angle(0)
		else:
			self.labelProperties.set_angle(270)
		self.hpanedMain.set_position(-1)			

	def on_expanderTags_expanded(self, widgt, *args):
		''' Toggle between compact and full view '''	
		if self.expanderTags.get_expanded() == True: 
			self.labelTags.set_angle(0)
		else:
			self.labelTags.set_angle(270)
		if self.expanderProperties.get_expanded() == False:
			self.hpanedMain.set_position(-1)

	def __init_treeviewBookmarks(self):
		model = self.__create_model_treeviewBookmarks(self._app.Bookmarks.get_iterree())
		self.treeviewBookmarks.set_model(model)
		self.__add_columns_treeviewBookmarks( self.treeviewBookmarks, model)
		targets = [('text/plain', 0, 0),('STRING', 0, 1)]		
		self.treeviewBookmarks.enable_model_drag_source(gtk.gdk.BUTTON1_MASK,
						  targets, gtk.gdk.ACTION_MOVE)
		self.treeviewBookmarks.enable_model_drag_dest(targets, gtk.gdk.ACTION_MOVE)
		self.treeviewBookmarks.set_search_column(1)
		self.treeviewBookmarks.get_selection().select_path(0,)
		self.treeviewBookmarks.set_cursor(0, focus_column=None, start_editing=False)
	
	def __reload_treeviewBookmarks(self):
		m, paths = self.treeviewBookmarks.get_selection().get_selected_rows()
		model = self.__create_model_treeviewBookmarks(self._app.Bookmarks.get_iterree())
		self.treeviewBookmarks.set_model(self.BookmarksFilter)
		if self.check_search_status() == False:
			self.treeviewBookmarks.set_model(model) 
		else:
			self.treeviewBookmarks.set_model(self.BookmarksFilter)
					
		self.BookmarkExpander.restore()	   
		try:
			self.treeviewBookmarks.get_selection().select_path(paths[0])
			self.treeviewBookmarks.set_cursor(paths[0], focus_column=None, start_editing=False)
			self.show_bookmark(self._app.selected_bookmark)
		except:
			self.treeviewBookmarks.get_selection().select_path(0,)
			self.treeviewBookmarks.set_cursor(0, focus_column=None, start_editing=False)	

	def __add_columns_treeviewBookmarks(self, treeview, model):
		columns = []
		col = gtk.TreeViewColumn()
		col.set_title(_('Name'))
		render_pixbuf = gtk.CellRendererPixbuf()
		col.pack_start(render_pixbuf, expand=False)
		col.add_attribute(render_pixbuf, 'pixbuf', 4)
		render_text = gtk.CellRendererText()
		col.pack_start(render_text, expand=True)
		col.add_attribute(render_text, 'text', 1)
		col.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
		col.set_resizable(True)
		columns.append(col)
		urlcol = gtk.TreeViewColumn(_('URL'), gtk.CellRendererText(), markup=2)
		urlcol.set_expand(True)
		columns.append(urlcol)		 
		for column in columns:
			treeview.append_column(column)		
		
	def __create_model_treeviewBookmarks(self, data):
		store = gtk.TreeStore(gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_PYOBJECT,
							  gtk.gdk.Pixbuf)
		if data != None:
			id = 0
			iters = {}
			default_icon = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'www.png'))
			dir_icon = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'dir-closed.png'))
			for parent, child in data:
				icon = None
				child.set('id', str(id))
				child.parent = parent
				id += 1
				if parent == None:
					name = 'Webmarks'
					url = ''
					parent_id = None
					icon = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'dir-webmarks.png'))					
				elif child.tag == 'dir':
					name = str(child.get("name"))
					url = ''
					parent_id = iters[parent.get("id")]
					icon = dir_icon
				else:
					name = str(child.get("name"))
					url = child.get("url")
					parent_id = iters[parent.get("id")]
					iconBinaryData = None
					try:
						iconBinaryData = Bookmarkhelper(child).get_binary_icon()
					except:
						iconBinaryData = None
					if iconBinaryData != None:
						try:								
							loader = gtk.gdk.PixbufLoader()								
							loader.write(iconBinaryData)
							loader.close()
							icon = loader.get_pixbuf()
						except:
							try:
								iconFile, ipath = mkstemp(suffix='.bmp')
								os.write(iconFile, iconBinaryData)
								os.close(iconFile)
								icon = gtk.gdk.pixbuf_new_from_file(ipath)
							except:								
								icon = default_icon
						if icon == None:
							icon = default_icon
					else:
						icon = default_icon
				pwidth = icon.get_width()
				pheight = icon.get_height()
				pfact = float(pwidth) / float(pheight)
				oheight = float(self._app.Settings.iconsize_tree) / pfact
				icon = icon.scale_simple(int(self._app.Settings.iconsize_tree), int(oheight), 3)
				iter = store.append(parent_id, row=(child.get("id"), name, url, child, icon))
				iters[child.get("id")] = iter
		self._app.last_id = id-1
		self.BookmarksFilter = store.filter_new()
		self.BookmarksFilter.set_visible_func(self.visibleFunc, data=None)
		return store

	def onEntryChanged(self, entry, data):
		filterText = entry.get_text()
		self.visibleItems = []
	
	def visibleFunc(self, model, iter, data=None):
		if self.check_search_status() == False:
			return True
		id = model[iter][0]
		name = model[iter][1]
		url = model[iter][2]
		child = model[iter][3]
		desc = child.get("desc") or ''
		tagstr = child.get("tags")
		tags = None
		if tagstr:
			tags = string.split(tagstr, ',')		
		type = child.tag
		if type == 'Webmarks':
			return True
		if type == 'dir':
			return id in self.visibleItems
		elif type == 'webmark':
			matchtags = self.tableTagfilter.get_tags()
			if matchtags != None:
				if tags == None:
					return False
				checktags = filter(lambda x: x in tags, matchtags)		
				if self.radiobuttonTagmodeAny.get_active() == True:		   
					if checktags == []:
						return False
				else:		   
					if checktags != matchtags:
						return False				
			if string.strip(self.entrySearch.get_text()) == '':
				self.__append_search_parents(model, iter)
				return True
			searchcols = [name, url, desc]
			Searchstring = self.entrySearch.get_text()
			searchstring = string.lower(string.strip(Searchstring))
			for col in searchcols:
				if col:
					if searchstring in string.lower(col):
						self.__append_search_parents(model, iter)
						return True
		return False
	
	def __append_search_parents(self, model, iter):
		parentIter = model.iter_parent(iter)
		if parentIter:
			parentItem = model[parentIter][0]	
			if parentItem not in self.visibleItems:
				self.visibleItems.append(parentItem)
				path = model.get_path(parentIter)
				model.row_changed(path, parentIter)
				self.__append_search_parents(model, parentIter)	
	
	def on_treeviewBookmarks_cursor_changed(self, widget):
		if self.buttonEditApply.get_property('sensitive') == True:
			self.warn_unsaved()	
		else:
			model, iter = widget.get_selection().get_selected()
			if iter != None:
				parent = None
				row = model[iter]
				parentiter = model.iter_parent(iter)
				if parentiter != None:
					parentrow = model[parentiter]
					parent = parentrow[3]
				child = row[3]
				self._app.selected_bookmark = child
				self._app.selected_bookmark.parent = parent
				self.show_bookmark(self._app.selected_bookmark)
				if self._app.selected_bookmark.tag == 'Webmarks':
					self.toolbuttonDelete.set_sensitive(False)
				else:
					self.toolbuttonDelete.set_sensitive(True)
				return

	def on_treeviewBookmarks_button_release_event(self, widget, event):   
		if event.button == 3:
			self.menuPopupBookmarks.popup(None, None, None, event.button, event.time)
			if self._app.selected_bookmark.tag == 'webmark':
				self.menuitemOrderTree.hide()
				self.show_menuitemsLaunch(True)
			else:
				self.menuitemOrderTree.show()
				self.show_menuitemsLaunch(False)
			
	def on_treeviewBookmarks_button_press_event(self, widget, event):   
		if event.type == gtk.gdk._2BUTTON_PRESS:
			if self._app.selected_bookmark.tag in ('Webmarks','dir'):
				model, iter = widget.get_selection().get_selected()
				if iter == None:
					return None
				path = model.get_path(iter)
				if widget.row_expanded(path):
					widget.collapse_row(path)
				else:
					widget.expand_row(path, False)													
				return None			
			if self._app.selected_bookmark.tag != 'webmark':
				return None
			appiter = self.comboboxEditApp.get_active_iter()
			appmodel = self.comboboxEditApp.get_model()
			approw = appmodel[appiter]
			plugin = approw[2]
			plugin.launch(self._app.selected_bookmark.get('url'))
			if self._app.Settings.close_on_launch == True:
				self.close()
		return				
	
	def on_treeviewBookmarks_row_expanded(self, treeview, iter, path, *args):
		self.BookmarkExpander.expand_row(path)
		
	def on_treeviewBookmarks_row_collapsed(self, treeview, iter, path, *args):
		self.BookmarkExpander.collapse_row(path)		
	
	def on_treeviewBookmarks_drag_drop(self, widget, context, x, y, timestamp):
		if self.check_search_status() == True:
			context.finish(True, False, timestamp)
			title = _('Info')
			text = _('Sorting is not possible on search/tag results.\n\
Please clear all search terms and tags and try again!')
			dialog = Dialogs.DialogMessage(text, title)
			return False
		text = '\n'.join([str(t) for t in context.targets])
		widget.stop_emission('drag_drop')
		drag_source = context.get_source_widget()
		Model, Iter = drag_source.get_selection().get_selected()
		model = Model
		iter = Iter
		row = model[iter]
		id = row[0]
		name = row[1]
		url = row[2]
		childElement = row[3]
		if childElement.tag == 'Webmarks':
			context.finish(True, False, timestamp)
			return False
		icon = row[4]
		oldParent = childElement.parent
		if oldParent != None:		
			wname = widget.get_name()
			drop_info = widget.get_dest_row_at_pos(x, y)
			path, position = drop_info
			diter = model.get_iter(path)
			drow = model[diter]
			dname = drow[1]
			targetElement = drow[3]
			childIter = iter
			childDiter = diter			
			childRow=(id, name, url, childElement, icon)
			parentIter = model.iter_parent(iter)		
			oldindex = None
			newindex = None
			newParent = targetElement.parent
			if newParent == None:
				newParent = targetElement
			NewparentIter = model.iter_parent(diter)		
			children = newParent.getchildren()
			for index, child in enumerate(children):					
				if child == targetElement:
					newindex = index	
			old_children = oldParent.getchildren()
			for index, child in enumerate(old_children):
				if child == childElement:
					oldindex = index						
			if targetElement.tag == 'webmark':												
				if (position == gtk.TREE_VIEW_DROP_BEFORE
					or position == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
					try:
						inserit = model.insert_before(NewparentIter, childDiter, childRow)
					except:
						context.finish(True, False, timestamp)
						return False				
				else:			
					try:
						
						inserit = model.insert_after(NewparentIter, childDiter, childRow)
						if oldParent != newParent and position == gtk.TREE_VIEW_DROP_AFTER:
							newindex = newindex+1
					except:
						context.finish(True, False, timestamp)
						return False
				model.remove(childIter)		
				if newindex != None:
					oldParent.remove(childElement)
					newParent.insert(newindex, childElement)
				self.__reload_treeviewBookmarks()								
			else:				
				if (position == gtk.TREE_VIEW_DROP_INTO_OR_AFTER
					or position == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
					newParent = targetElement
					oldParent.remove(childElement)
					newParent.append(childElement)
					self.__reload_treeviewBookmarks()
				else:	
					if position == gtk.TREE_VIEW_DROP_BEFORE:
						try:
							inserit = model.insert_before(NewparentIter, childDiter, childRow)
							if oldParent != newParent \
							and newindex != 0:						
								newindex = newindex-1
						except:
							context.finish(True, False, timestamp)
							return False				
					else:
						try:
							inserit = model.insert_after(NewparentIter, childDiter, childRow)
							if oldParent != newParent:
								newindex = newindex+1
						except:
							context.finish(True, False, timestamp)
							return False
					if newindex != None:
						oldParent.remove(childElement)
						newParent.insert(newindex, childElement)
					else:
						self.__reload_treeviewBookmarks()
			self._app.Bookmarks.store()
			self.__reload_treeviewBookmarks()
			self.BookmarksFilter.refilter()
			
			gobject.idle_add(self.__reload_comboboxEditParent)
			gobject.idle_add(self._app.Tray.reset_menu)
			context.finish(True, False, timestamp)
		return

	def on_radiobuttonTagmodeAny_toggled(self, widget):
		if self.tableTagfilter.get_tags() not in ([], None):
			self.refresh_searchtree()
			
	def check_search_status(self):
		''' Check if search-filters are used.
		
		This is important to determine which tree-model should be used for the
		bookmarks-treeview.
		
		Return	boolean True|False
		'''
		if (len(self.entrySearch.get_text()), 
		self.tableTagfilter.get_tags()) == (0, None):
			return False
		return True

	def on_entrySearch_changed(self, widget, *event):
		if len(self.entrySearch.get_text()) >= 2 \
		or len(self.entrySearch.get_text()) == 0:
			self.refresh_searchtree() # idle??
		self.buttonClearSearch.grab_default()
		self.entrySearch.set_activates_default(True)			
				
	def refresh_searchtree(self):
		self.visibleItems = []
		try:
			self.BookmarksFilter.refilter()
		except:
			pass
		self.BookmarkExpander.clear()
		if self.check_search_status() == False:
			try:
				self.treeviewBookmarks.set_model(self.BookmarksFilter.get_model())
			except:
				pass
			self.BookmarkExpander.restore() 
		else:
			self.treeviewBookmarks.set_model(self.BookmarksFilter)
			self.treeviewBookmarks.expand_all()				
			
	def on_buttonClearSearch_clicked(self, widget, *event):
		self.entrySearch.set_text('')
	
	def __create_model_comboboxEditParent(self, data):
		store = gtk.TreeStore(gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_PYOBJECT)
		if data != None:
			id = 0
			iters = {}
			for parent, child in data:
				child.set('id', str(id))
				id += 1
				if parent == None:
					iter = store.append(None, row=('Webmarks', child.get("id"), child))
					iters[child.get("id")] = iter
				elif child.tag == 'dir':
					name = str(child.get("name"))
					iter = store.append(iters[parent.get("id")], row=(name, child.get("id"), child))
					iters[child.get("id")] = iter
		return store
	
	def __init_treeviewTaglist(self):
		model = self.__create_model_treeviewTaglist(self._app.Tags.get_tags())
		self.treeviewTaglist.set_model(model)
		self.__add_columns_treeviewTaglist( self.treeviewTaglist, model)
		self.treeviewTaglist.enable_model_drag_source(gtk.gdk.BUTTON1_MASK,
						  [('STRING', 0, 0),('STRING', 0, 1)],
						  gtk.gdk.ACTION_DEFAULT | gtk.gdk.ACTION_COPY)
		targets = [('STRING', 0, 0),('STRING', 0, 1)]
		self.treeviewTaglist.enable_model_drag_dest(targets,gtk.gdk.ACTION_DEFAULT)	   
		
	def on_treeviewTaglist_drag_begin(self, *dragdata):
		pass
	
	def on_treeviewTaglist_button_release_event(self, widget, event):
		if event.button == 3:
			self.menuPopupTags.popup(None, None, None, event.button, event.time)	

	def on_treeviewElementTaglist_button_release_event(self, widget, event):
		if event.button == 3:
			self.menuPopupMarktags.popup(None, None, None, event.button, event.time)
			
	def on_menuitemRemoveTag_activate(self, widget, *event):
		model, iter = self.treeviewElementTaglist.get_selection().get_selected()
		if iter != None:
			row = model[iter]
			name = row[0]		 
		Bookmarkhelper(self._app.selected_bookmark).remove_tag(name)
		self.__reload_treeviewElementTaglist()
		
	def on_menuitemDeleteTag_activate(self, widget, *event):
		model, iter = self.treeviewTaglist.get_selection().get_selected()
		if iter != None:
			row = model[iter]
			name = row[0]
		self._app.Tags.remove(name)
		self._app.Tags.store()
		gobject.idle_add(self.__reload_treeviewTaglist)
		gobject.idle_add(self.__reload_treeviewBookmarks)

	def __init_treeviewElementTaglist(self):
		tags = []
		if self._app.selected_bookmark != None:
			tags = self._app.selected_bookmark.get_tags()
		model = self.__create_model_treeviewTaglist(tags)
		self.treeviewElementTaglist.set_model(model)
		self.__add_columns_treeviewTaglist( self.treeviewElementTaglist, model)
		self.treeviewElementTaglist.enable_model_drag_source(gtk.gdk.BUTTON1_MASK,
						  [('STRING', 0, 0),('STRING', 0, 1)],
						  gtk.gdk.ACTION_DEFAULT | gtk.gdk.ACTION_COPY)
		targets = [('STRING', 0, 0),('STRING', 0, 1)]
		self.treeviewElementTaglist.enable_model_drag_dest(targets,gtk.gdk.ACTION_DEFAULT)

	def on_treeviewElementTaglist_drag_motion(self, wid, context, x, y, time):
		context.drag_status(gtk.gdk.ACTION_COPY, time)
		return True		

	def on_tableTagfilter_drag_motion(self, wid, context, x, y, time):
		context.drag_status(gtk.gdk.ACTION_COPY, time)
		
		return True 

	def on_tableTagfilter_drag_drop(self, widget, context, x, y, etime):

		name = widget.get_name()
		drag_source = context.get_source_widget()
		model, iter = drag_source.get_selection().get_selected()
		row = model[iter]
		tagstr = row[0]
		self.tableTagfilter.add_tag(tagstr)
		self.refresh_searchtree()
		self.buttonTagfilterClear.grab_default()
		self.buttonTagfilterClear.grab_focus()
		context.finish(True, False, etime)
		
	def on_buttonTagfilterClear_clicked(self, widget, *event):
		self.tableTagfilter.clear()
		self.refresh_searchtree()
		self.toolbuttonAddBookmark.grab_focus()
		self.toolbuttonAddBookmark.grab_default()

	def on_treeviewElementTaglist_drag_data_received(self, widget, context, x, y, selection, info, etime):
		name = widget.get_name()
		drag_source = context.get_source_widget()
		model, iter = drag_source.get_selection().get_selected()
		row = model[iter]
		tagstr = row[0]
		Bookmarkhelper(self._app.selected_bookmark).add_tag(tagstr)
		self.__reload_treeviewElementTaglist()
		self._app.Bookmarks.store()
		return
		
	def __reload_treeviewTaglist(self):
		model = self.__create_model_treeviewTaglist(self._app.Tags.get_tags())
		self.treeviewTaglist.set_model(model)
		
	def __reload_treeviewElementTaglist(self):
		tags = []
		tags = Bookmarkhelper(self._app.selected_bookmark).get_tags()
		model = self.__create_model_treeviewTaglist(tags)
		self.treeviewElementTaglist.set_model(model)			   
	
	def __create_model_treeviewTaglist(self, data):
		store = gtk.ListStore(gobject.TYPE_STRING)
		if data != None:
			for tag in data:
				iter = store.append(row=(tag,))
		return store	   
	
	def __add_columns_treeviewTaglist(self, treeview, model):
		columns = []
		namecol = gtk.TreeViewColumn(_('Tags'), gtk.CellRendererText(), markup=0)
		namecol.set_expand(True)
		columns.append(namecol)		
		for column in columns:
			treeview.append_column(column)	
	
	def __init_comboboxEditParent(self):
		model = self.__create_model_comboboxEditParent(self._app.Bookmarks.get_iterree())
		self.comboboxEditParent.set_model(model)
		self.comboboxEditParent.set_active(0)
		
	def __reload_comboboxEditParent(self):
		last = self.comboboxEditParent.get_active()
		model = self.__create_model_comboboxEditParent(self._app.Bookmarks.get_iterree())
		self.comboboxEditParent.set_model(model)
		self.comboboxEditParent.set_active(last)
		self.buttonEditApply.set_sensitive(False)
	 
	def on_menuitemAddBookmark_activate(self, widget, *event):
		self.add_bookmark()
	
	def on_menuitemAddDir_activate(self, widget, *event):
		self.add_bookmarkdir()
	
	def on_menuitemDeleteBookmark_activate(self, widget, *event):
		title = _('Request')
		text = _('Do you really want to delete this entry?')
		dialog = Dialogs.DialogRequest(text, title, False, self.delete_bookmark, self._app.selected_bookmark)
		
	def on_menuitemOrderTree_activate(self, widget, *event):
		self._app.Bookmarks.order_tree(self._app.selected_bookmark)
		self._app.Bookmarks.store()
		self.refresh_bookmarks()
		self.BookmarksFilter.refilter()

	def __show_bookmark(self, Element):
		Bookmark = Bookmarkhelper(Element)
		self.labelOverviewHead.set_markup(Bookmark.get_overview_head())
		self.labelDesc.set_markup(Bookmark.get_overview_body())
		self.labelOverviewFooter.set_markup(Bookmark.get_overview_footer())
		self.entryEditName.set_text(Bookmark.get_name())
		self.entryEditUrl.set_text(Bookmark.get_url())
		desc_buffer = gtk.TextBuffer()
		desc_buffer.set_text(Bookmark.get_desc())
		self.textviewEditDesc.set_buffer(desc_buffer)
		default_icon = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'www.png'))
		dir_icon = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'dir-closed.png'))		
		if self._app.selected_bookmark.parent != None:
			parent_id = self._app.selected_bookmark.parent.get("id")
			row = GTK_tools().search_combolist_column(self.comboboxEditParent, 1, parent_id)
			if row:
				self.comboboxEditParent.set_active_iter(row.iter)
		if self._app.selected_bookmark.get("app"):
			appstr = self._app.selected_bookmark.get("app")
			try:
				row = GTK_tools().search_combolist_column(self.comboboxEditApp, 1, appstr)
			except:
				row = None
			if not row:
				row = GTK_tools().search_combolist_column(self.comboboxEditApp, 1, self._app.Settings.default_launcher)
			if row:
				self.comboboxEditApp.set_active_iter(row.iter)		
		else:
			row = GTK_tools().search_combolist_column(self.comboboxEditApp, 1, self._app.Settings.default_launcher)
			if row:
				self.comboboxEditApp.set_active_iter(row.iter)
		if Element.tag == 'Webmarks':
			self.comboboxEditParent.set_active(-1)
			self.comboboxEditParent.set_sensitive(False)
			self.frameElementTaglist.set_sensitive(False)
			self.frameEdit.set_sensitive(False)
			ipath = os.path.join(self._app.Settings.pixmapdir, 'dir-webmarks.png')
			pixbufOverviewIcon = gtk.gdk.pixbuf_new_from_file(ipath)			
		else:
			self.comboboxEditParent.set_sensitive(True)
			self.entryEditUrl.set_sensitive(True)
			self.textviewEditDesc.set_sensitive(True)
			self.comboboxEditApp.set_sensitive(True)
			self.frameElementTaglist.set_sensitive(True)
			self.frameEdit.set_sensitive(True)			
			if Element.tag == 'dir':
				self.entryEditUrl.set_sensitive(False)
				self.comboboxEditApp.set_sensitive(False)
				self.frameElementTaglist.set_sensitive(False)
				pixbufOverviewIcon = dir_icon
			elif Bookmark.get_binary_icon() != None:
				iconBinaryData = Bookmark.get_binary_icon()				
				if iconBinaryData != None:
					try:								
						loader = gtk.gdk.PixbufLoader()								
						loader.write(iconBinaryData)
						loader.close()
						pixbufOverviewIcon = loader.get_pixbuf()
					except:
						try:
							iconFile, ipath = mkstemp(suffix='.bmp')
							os.write(iconFile, iconBinaryData)
							os.close(iconFile)
							pixbufOverviewIcon = gtk.gdk.pixbuf_new_from_file(ipath)
						except:								
							pixbufOverviewIcon = default_icon
					if pixbufOverviewIcon == None:
						pixbufOverviewIcon = default_icon
				else:
					pixbufOverviewIcon = default_icon					
			else:
				pixbufOverviewIcon = default_icon
		pwidth = pixbufOverviewIcon.get_width()
		pheight = pixbufOverviewIcon.get_height()
		pfact = float(pwidth) / float(pheight)
		oheight = float(self._app.Settings.iconsize_overview) / pfact
		pixbufOverviewIcon = pixbufOverviewIcon.scale_simple(int(self._app.Settings.iconsize_overview), int(oheight), 3)					
		self.imageOverviewIcon.set_from_pixbuf(pixbufOverviewIcon)
		self.imageEditIcon.set_from_pixbuf(pixbufOverviewIcon)				
		self.__reload_treeviewElementTaglist()
		
	def show_bookmark(self, Element):
		self.selected_bookmark_backup = Element
		self.__show_bookmark(Element)
		self.buttonEditApply.set_sensitive(False)
		
	def show_new_bookmark(self, Element):
		self.__show_bookmark(Element)		
		
	def reshow_bookmark(self, Element):
		self.__show_bookmark(Element)		

	def on_buttonAddTag_clicked(self, widget, *event):
		tag = self.entryAddTag.get_text()
		if tag == '':
			return False
		self._app.Tags.add(tag)
		self._app.Tags.store()
		self.entryAddTag.set_text('')
		self.__reload_treeviewTaglist()
		self.toolbuttonAddBookmark.grab_focus()
		self.toolbuttonAddBookmark.grab_default()

	def on_entryAddTag_changed(self, widget, *event):
		self.buttonAddTag.grab_default()
		self.entryAddTag.set_activates_default(True)

	def getcbtext(self):  
		return gtk.Clipboard().wait_for_text()
	
	def on_buttonFetchTitle_clicked(self, widget, *args):
		if self.entryEditUrl.get_text():
			title = self._app.Bookmarks.fetch_bookmark_title(self.entryEditUrl.get_text())
			print 'title: %s' % title
			if title != None:
				self.entryEditName.set_text(title)
			else:
				self.entryEditName.set_text(self.entryEditUrl.get_text())

	def on_buttonFetchIcon_clicked(self, widget, *args):
		if self.entryEditUrl.get_text():
			favicon = self._app.Bookmarks.fetch_favicon(self.entryEditUrl.get_text())
			if favicon != None:
				self._app.selected_bookmark.set('icon', favicon)
				self.reshow_bookmark(self._app.selected_bookmark)
				self.buttonEditApply.set_sensitive(True)
				
	
	def on_buttonFetchDesc_clicked(self, widget, *args):
		if self.entryEditUrl.get_text():
			desc = self._app.Bookmarks.fetch_bookmark_info(self.entryEditUrl.get_text())
			if desc != None:
				desc_buffer = self.textviewEditDesc.get_buffer()
				desc_buffer.set_text(desc)
				self.textviewEditDesc.set_buffer(desc_buffer)
				
	def on_notebookEditBookmark_switch_page(self, notebook, page, page_num):
		if page_num == 0 and self.buttonEditApply.get_property('sensitive') == True:
			self.warn_unsaved()

	def warn_unsaved(self):
		title = _('Warning:')
		text = _('You have unsaved changes in this entry, do you really want to\n\
discard them now?\n\n\
		Else click Abort below and apply your changes.')
		DialogWarn = Dialogs.DialogRequest(text, title, longtext=False, returnfunc=self.discard_unsaved, cancel_func=self.rescue_unsaved)
		pass
	
	def rescue_unsaved(self, *args):
		self.notebookEditBookmark.set_current_page(1)
		pass
	
	def discard_unsaved(self, *args):
		if self.selected_bookmark_backup != None:
			self._app.selected_bookmark = self.selected_bookmark_backup
			self.show_bookmark(self._app.selected_bookmark)
			self.selected_bookmark_backup = None
		else:
			self.show_bookmark(self._app.selected_bookmark)
		pass	

	def on_toolbuttonAddBookmark_clicked(self, widget, *event):
		self.add_bookmark()
			
	def add_bookmark(self):
		self.toolbuttonCompactView.set_active(False)
		self.expanderProperties.set_expanded(True)		
		self._app.selected_bookmark = ET.Element('webmark')
		self._app.selected_bookmark.parent = None
		clipboard = self.getcbtext()
		if tools.validate_url(clipboard) == True:
			self._app.selected_bookmark.set('url', clipboard)
			title = clipboard
			if self._app.Settings.autofetch == True:
				try:
					title = self._app.Bookmarks.fetch_bookmark_title(clipboard)
					if title == None:
						title = clipboard
				except:
					title = clipboard
				self._app.selected_bookmark.set('name', title)
				try:
					info = self._app.Bookmarks.fetch_bookmark_info(clipboard)
					self._app.selected_bookmark.set('desc', info)
				except:
					pass
				favicon = self._app.Bookmarks.fetch_favicon(clipboard)
				if favicon != None:
					self._app.selected_bookmark.set('icon', favicon)
		
		self.notebookEditBookmark.set_current_page(1)
		self.show_new_bookmark(self._app.selected_bookmark)
		if self.comboboxEditParent.get_active() == -1:
			self.comboboxEditParent.set_active(0)
		row = GTK_tools().search_combolist_column(self.comboboxEditApp, 1, self._app.Settings.default_launcher)
		if row:
			self.comboboxEditApp.set_active_iter(row.iter)						
		
	def on_toolbuttonAddDir_clicked(self, widget, *event):
		self.add_bookmarkdir()
			
	def add_bookmarkdir(self):
		self.toolbuttonCompactView.set_active(False)
		self.expanderProperties.set_expanded(True)		
		self._app.selected_bookmark = ET.Element('dir')
		self._app.selected_bookmark.parent = None
		self.notebookEditBookmark.set_current_page(1)
		self.show_new_bookmark(self._app.selected_bookmark)
		if self.comboboxEditParent.get_active() == -1:
			self.comboboxEditParent.set_active(0)			
		
	def on_toolbuttonDelete_clicked(self, widget, *event):
		title = _('Request')
		text = _('Do you really want to delete this entry?')
		dialog = Dialogs.DialogRequest(text, title, False, self.delete_bookmark, self._app.selected_bookmark)		
		
	def delete_bookmark(self, Bookmark):
		model, iter = self.treeviewBookmarks.get_selection().get_selected()
		row = model[iter]
		if self.check_search_status() == True:
			model.get_model().remove(model.convert_iter_to_child_iter(iter))
		else:
			model.remove(iter)
		Parent = Bookmark.parent
		if Parent != None:
			Parent.remove(Bookmark)
			gobject.idle_add(self.__reload_comboboxEditParent)
			gobject.idle_add(self._app.Tray.reset_menu)			
		self._app.Bookmarks.store()
		
	def on_toolbuttonShowSettings_clicked(self, widget, *event):
		self.ShowSettings()
		
	def ShowSettings(self):
		settingswin = WindowSettings(self._app)
		settingswin.Show()
		
	def on_comboboxEditParent_changed(self, widget, *event):
		self.buttonEditApply.set_sensitive(True)
		self.buttonEditApply.grab_default()
		self.buttonEditApply.grab_focus()
		
	def on_entryEditUrl_changed(self, widget, *event):
		self.buttonEditApply.set_sensitive(True)
		self.buttonEditApply.grab_default()
		self.entryEditUrl.set_activates_default(True)
		
	def on_entryEditName_changed(self, widget, *event):
		self.buttonEditApply.set_sensitive(True)
		self.buttonEditApply.grab_default()
		self.entryEditName.set_activates_default(True)
		
	def on_textviewEditDesc_key_release_event(self, widget, *event):
		self.buttonEditApply.set_sensitive(True)
		self.buttonEditApply.grab_default()
		
	def on_comboboxEditApp_changed(self, widget, *event):
		self.buttonEditApply.set_sensitive(True)
		self.buttonEditApply.grab_default()
		self.buttonEditApply.grab_focus()		
	
	def on_buttonEditApply_clicked(self, widget, *event):
		widget.set_sensitive(False)
		time.sleep(0.1)
		self._app.selected_bookmark.set('name', self.entryEditName.get_text())
		if self._app.selected_bookmark.tag == 'webmark':
			self._app.selected_bookmark.set('url', self.entryEditUrl.get_text())
		descbuffer = self.textviewEditDesc.get_buffer()
		descstr = descbuffer.get_text(descbuffer.get_start_iter(), descbuffer.get_end_iter())
		self._app.selected_bookmark.set('desc', descstr)
		appiter = self.comboboxEditApp.get_active_iter()
		appmodel = self.comboboxEditApp.get_model()
		try:
			approw = appmodel[appiter]
			if approw:
				self._app.selected_bookmark.set('app', approw[1])
		except:
			pass
		iterparent = self.comboboxEditParent.get_active_iter()
		if iterparent != -1:
			Element = self._app.selected_bookmark
			model_parent = self.comboboxEditParent.get_model()
			row = model_parent[iterparent]
			newParent = row[2]
			oldParent = self._app.selected_bookmark.parent
			if oldParent != None:
				if newParent in (oldParent, Element):
					pass
				else:
					oldParent.remove(Element)
					newParent.append(Element)
			else:
				newParent.append(Element)
		self._app.Bookmarks.store()
		print 'stored bookmarks!'
		gobject.idle_add(self.__reload_comboboxEditParent)
		gobject.idle_add(self.__reload_treeviewBookmarks)
		gobject.idle_add(self._app.Tray.reset_menu)
		print 'reloaded gui!'
		self.selected_bookmark_backup = None

	def on_mainwindow_delete_event(self, widget, *event):
		self.close()
		return True
	
	def on_toolbuttonExit_clicked(self, widget, *event):
		self.destroy_event(widget, event)
		return True
	
	def on_toolbuttonInfo_clicked(self, widget, *event):
		gtk.about_dialog_set_url_hook(self.open_info_url)
		wtree = gtk.glade.XML(self.gladefile,"aboutdialog", webmarx.APP)
		self.aboutdialog = wtree.get_widget("aboutdialog")
		self.aboutdialog.connect('response', self.on_aboutdialog_response)
		licencepath = os.path.join(self._app.Settings['docdir'], 'COPYING')
		f = open(licencepath, 'r')
		licencetext = f.read()
		f.close()
		self.aboutdialog.set_license(licencetext)
		logo = gtk.gdk.pixbuf_new_from_file(os.path.join(self._app.Settings.pixmapdir, 'logo.png'))
		self.aboutdialog.set_logo(logo)
		self.aboutdialog.show()
		return True
	
	def open_info_url(self, widget=None, url=settings.__url__):
		launcher = launchDefaultapp.Plugin()
		launcher.launch(url)
		return True		
	
	def on_aboutdialog_response(self, widget, *response):
		widget.destroy ()		
		return True	
		
	def destroy_event(self, widget, *event):
		self.mainwindow.destroy()
		self.mainwindow = None
		gtk.main_quit()
		return None
				
	def close(self, *args):
		if self._app.Settings.usetray == True \
		and self._app.Settings.close_to_tray == True \
		and self._app.Tray != None:
			self.mainwindow.hide()
		else:
			self.mainwindow.destroy()
			self.mainwindow = None
			gtk.main_quit()
		return True

class WindowSettings(gobject.GObject):
	''' The main gui. '''
	def __init__(self, app):
		gobject.GObject.__init__(self)
		self._app = app
		self.gladefile = self._app.Settings.libdir + "/Webmarks.glade"
		self.Autoconnect = Autoconnect(self)
		self.autoconnect = self.Autoconnect.autoconnect
		self.disconnect = self.Autoconnect.disconnect
		self.selected_launcher = None
		self.selected_importfilter = None
		
	def Show(self):
		''' Initializes the GUI and assigns all initial parameters to the widgets on startup '''		
		self.wTree = gtk.glade.XML(self.gladefile, "dialogSettings", webmarx.APP)
		for widget in self.wTree.get_widget_prefix(''):
			wname = widget.get_name()
			setattr(self, str(wname), widget)
		icon = os.path.join(self._app.Settings.pixmapdir, 'trayicon.png')
		self.dialogSettings.set_icon_from_file(icon)			
		self.labelImportDesc.set_line_wrap(True)
		self.buttonImportConfig.connect('clicked', self.on_buttonImportConfig_clicked)		
		self.set_values(self._app.Settings)
		self.__init_treeviewCommands()
		self.autoconnect()
		if self._app.importPlugins:
			self.__initImportPlugins(self._app.importPlugins)
			self.__initLauncherPlugins()
		self.dialogSettings.present()
		
	def __create_model_comboboxDefaultLauncher(self, data):
		store = gtk.TreeStore(gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_PYOBJECT)
		if data != None:
			id = 0
			iters = {}
			for name, plugin in data:
				pname = plugin.get_name()
				iter = store.append(None, row=(pname, name, plugin))
		return store		
		
	def __initImportPlugins(self, plugin_names):		
		iplugins = []
		Plugins = self._app.importPlugins
		for plugin in Plugins:
			iplugins.append((plugin.get_name(), plugin))
		model = self.__create_model_comboboxImportfilter(iplugins)
		self.comboboxImportfilter.set_model(model)
		self.comboboxImportfilter.set_active(0)
		return None
	
	def __initLauncherPlugins(self):	
		plugins = []
		Plugins = self._app.launcherPlugins
		for plugin in Plugins:
			plugins.append((plugin.get_name(), plugin))
		launchers = self._app.Settings.launchers
		for name, command in launchers:
			plugin = PluginLaunchbutton(name, command)
			plugins.append((name, plugin))
		appmodel = self.__create_model_comboboxDefaultLauncher(plugins)
		self.comboboxDefaultLauncher.set_model(appmodel)
		row = GTK_tools().search_combolist_column(self.comboboxDefaultLauncher, 1, self._app.Settings.default_launcher)
		if row:
			self.comboboxDefaultLauncher.set_active_iter(row.iter)			
		return None	
	
	def __create_model_comboboxImportfilter(self, data):
		store = gtk.TreeStore(gobject.TYPE_STRING,
							  gobject.TYPE_STRING,
							  gobject.TYPE_PYOBJECT)
		if data != None:
			id = 0
			iters = {}
			iter = store.append(None, row=('Nothing selected', '', None))
			for name, plugin in data:
				pname = plugin.get_name()				
				iter = store.append(None, row=(pname, name, plugin))
		return store
	
	def on_comboboxImportfilter_changed(self, widget):
		iter = widget.get_active_iter()
		model = widget.get_model()
		row = model[iter]
		try:
			self.selected_importfilter = row[2]
		except:
			return False
		if self.selected_importfilter == None:
			self.buttonImportConfig.hide()
			self.labelImportDesc.set_text(_('%s!') % _('No import filter selected')) 
			self.activate_import(False)
			return
		self.labelImportDesc.set_text(self.selected_importfilter.get_description())
		self.activate_import(True)
		
		if self.selected_importfilter.haveconfig == True:
			self.buttonImportConfig.show_all()
		else:
			self.buttonImportConfig.hide()
		return
	
	def on_buttonImportConfig_clicked(self, widget):
		self.selected_importfilter.open_config()
	
	def on_checkbuttonImportOverwrite_toggled(self, widget):
		active = widget.get_active()
		activate = False if active == True else True
		self.labelImportdir.set_sensitive(activate)
		self.entryImportdir.set_sensitive(activate)		

	def activate_import(self, activate):
		self.labelImportfile.set_sensitive(activate)
		self.filechooserbuttonImportfile.set_sensitive(activate)
		self.checkbuttonImportOverwrite.set_sensitive(activate)
		self.checkbuttonImportOverwrite.set_active(False)
		self.labelImportdir.set_sensitive(activate)
		self.entryImportdir.set_sensitive(activate)
		self.buttonDoImport.set_sensitive(activate)
		
	def on_buttonDoImport_clicked(self, widget):
		self.do_import()
		
	def do_import(self):
		file = self.filechooserbuttonImportfile.get_filename()
		if not file:
			return False
		import_tree = self.selected_importfilter.get_tree(file)
		overwrite = self.checkbuttonImportOverwrite.get_active()
		if overwrite == False:
			dirname = self.entryImportdir.get_text()
			if dirname == '':
				return False
			children = import_tree.getroot().getchildren()
			newdir = ET.Element('dir')
			newdir.set('name', dirname)
			for child in children:
				newdir.append(child)
			self._app.Bookmarks.root.append(newdir)
		else:
			self._app.Bookmarks.tree = import_tree
		try:
			self._app.Window.refresh_bookmarks()
			self._app.Bookmarks.store()
		except:
			pass			
			
	def on_buttonFetchFavicons_clicked(self, widget):
		self.fetch_favicons()
		
	def fetch_favicons(self):
		self._app.Bookmarks.fetch_all_favicons()				

	def __create_model_treeviewCommands(self, data):
		store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING)
		if data != None:
			for name, command in data:
				iter = store.append(row=(name, command))
		return store
	
	def __add_columns_treeviewCommands(self, treeview, model):
		columns = []
		namecol = gtk.TreeViewColumn(_('Name'), gtk.CellRendererText(), markup=0)
		namecol.set_resizable(True)
		columns.append(namecol)
		comcol = gtk.TreeViewColumn(_('Command'), gtk.CellRendererText(), markup=1)
		comcol.set_expand(True)
		comcol.set_resizable(True)
		columns.append(comcol)					
		for column in columns:
			treeview.append_column(column)
			
	def on_ColumnUse_toggled(self, cellrenderertoggle, path, *args):
		return
			
	def __init_treeviewCommands(self):
		model = self.__create_model_treeviewCommands(self._app.Settings.launchers)
		self.treeviewCommands.set_model(model)
		self.__add_columns_treeviewCommands( self.treeviewCommands, model)

	def __refresh_treeviewCommands(self, launchers):
		model = self.__create_model_treeviewCommands(launchers)
		self.treeviewCommands.set_model(model)	   
		
	def set_values(self, settings):
		self.checkbuttonUseTray.set_active(settings.usetray)
		self.checkbuttonCloseToTray.set_sensitive(self.checkbuttonUseTray.get_active())
		self.checkbuttonCloseOnLaunch.set_active(settings.close_on_launch)
		self.checkbuttonCloseToTray.set_active(settings.close_to_tray)
		self.checkbuttonAutofetch.set_active(settings.autofetch)
		self.spinbuttonIconsizeTree.set_value(int(settings.iconsize_tree))
		self.spinbuttonIconsizeMenu.set_value(int(settings.iconsize_menu))
		self.spinbuttonIconsizeOverview.set_value(int(settings.iconsize_overview))
		
	def on_checkbuttonUseTray_toggled(self, widget, *args):
		self.checkbuttonCloseToTray.set_sensitive(widget.get_active())		

	def on_toolbuttonAddLauncher_clicked(self, widget, *args):
		self.selected_launcher = None
		self.entryLauncherName.set_text('')
		self.entryLauncherCommand.set_text('')		
		self.frameEditLauncher.show_all()
		
	def on_toolbuttonEditLauncher_clicked(self, widget, *args):
		model, iter = self.treeviewCommands.get_selection().get_selected()
		if iter != None:
			row = model[iter]
			name = row[0]
			command = row[1]
			self.selected_launcher = self._app.Settings['launchers'].index((name, command))
			self.entryLauncherName.set_text(name)
			self.entryLauncherCommand.set_text(command)
			self.frameEditLauncher.show_all()
			
	def on_toolbuttonDeleteLauncher_clicked(self, widget, *args):
		model, iter = self.treeviewCommands.get_selection().get_selected()
		if iter != None:
			row = model[iter]
			name = row[0]
			command = row[1]
			launchers = self._app.Settings['launchers']
			selected_launcher = launchers.index((name, command))
			launchers.remove((name, command))
			self.__refresh_treeviewCommands(launchers)		 
		
	def on_buttonApplyLauncher_clicked(self, widget, *args):
		newlauncher = (self.entryLauncherName.get_text(),self.entryLauncherCommand.get_text())
		if self.selected_launcher == None:
			launchers = self._app.Settings['launchers']
			
			launchers.append(newlauncher)
			self.__refresh_treeviewCommands(launchers)
		else:
			launchers = self._app.Settings['launchers']
			launchers[self.selected_launcher] = newlauncher
			self.__refresh_treeviewCommands(launchers)
		self.frameEditLauncher.hide()
		
	def on_buttonAbortLauncher_clicked(self, widget, *args):
		self.entryLauncherName.set_text('')
		self.entryLauncherCommand.set_text('')
		self.frameEditLauncher.hide()		
		
	def on_dialogSettings_response(self, widget, *response):
		print 'response: %s' % response[0]
		if response[0] in (1,2):
			print 'response! %s' % response[0]
			self._app.Settings['usetray'] = self.checkbuttonUseTray.get_active()
			self._app.Settings['close_on_launch'] = self.checkbuttonCloseOnLaunch.get_active()
			self._app.Settings['close_to_tray'] = self.checkbuttonCloseToTray.get_active()
			self._app.Settings['autofetch'] = self.checkbuttonAutofetch.get_active()
			self._app.Settings['iconsize_tree'] = self.spinbuttonIconsizeTree.get_text()
			self._app.Settings['iconsize_menu'] = self.spinbuttonIconsizeMenu.get_text()
			self._app.Settings['iconsize_overview'] = self.spinbuttonIconsizeOverview.get_text()
			self._app.Settings['launchers'] = []
			lmodel = self.treeviewCommands.get_model() 
			for row in lmodel:
				command = (row[0],row[1])
				self._app.Settings['launchers'].append(command)
			appiter = self.comboboxDefaultLauncher.get_active_iter()
			appmodel = self.comboboxDefaultLauncher.get_model()
			approw = appmodel[appiter]
			self._app.Settings['default_launcher'] = approw[1]
			self._app.Settings.store()
			if self._app.Settings['usetray'] == True:
				if self._app.Tray == None:
					self._app.loadTray()
			try:
				self._app.Window.refresh_settings()
			except:
				pass
			
			if response[0] == 2:
				widget.destroy ()			
		elif response[0] == 0:
			self._app.Settings.load()
			widget.destroy ()
		return True		
		
	def on_dialogSettings_delete_event(self, widget, *event):
		self.dialogSettings.destroy()
		self.dialogSettings = None
		return True
	
	def on_toolbuttonExit_clicked(self, widget, *event):
		self.destroy_event()
		return True
		
	def destroy_event(self, *args):
		self.dialogSettings.destroy()
		self.dialogSettings = None
		return None
	
class BookmarkExpander:
	''' This Class manages the expansion states for the bookmarks-tree '''
	def __init__(self, app, treeview):
		self._app = app
		self.treeview = treeview
		self.rows = []
		
	def clear(self):
		self.rows = []		
		
	def expand_row(self, row):
		self.rows.append(row)
		
	def collapse_row(self, row):
		if row == (0,):
			self.treeview.collapse_all()
			self.rows = []
			return
		self.rows.remove(row)
		
	def check_row(self, row):
		if row in self.rows:
			return True

	def restore(self):
		if self.rows == []:
			self.treeview.collapse_all()
			self.treeview.expand_to_path((0,))
		for row in self.rows:
			try:
				self.treeview.expand_to_path(row)
			except:
				pass
			
class TagTable(gtk.Table):
	''' The dnd tag-filter table '''
	def __init__(self, app):
		self._app = app
		gtk.Table.__init__(self, rows=1, columns=4, homogeneous=False)
		self.next_place = (0, 0)
		self.tags = {}
		targets = [('text/plain', 0, gtk.TARGET_SAME_APP),('STRING', 0, gtk.TARGET_SAME_APP)]
		self.drag_dest_set( gtk.DEST_DEFAULT_MOTION |
						gtk.DEST_DEFAULT_HIGHLIGHT | gtk.DEST_DEFAULT_DROP,
						targets, gtk.gdk.ACTION_COPY)
		ncolor = gtk.gdk.color_parse('#FFFFFF')
		self.modify_bg(gtk.STATE_NORMAL, ncolor) 
		self.set_row_spacings(1)
		self.set_col_spacings(1)			   
	
	def add_tag(self, tag):
		label = gtk.Label(tag)
		self.tags[tag] = label
		if self.next_place[0] == 4:
			self.next_place = (0, self.next_place[1]+1)
			self.resize(self.next_place[1]+1, 4)
		self.attach(label, self.next_place[0], self.next_place[0]+1, self.next_place[1], self.next_place[1]+1, xpadding=4)
		self.next_place = (self.next_place[0]+1, self.next_place[1])
		self.show_all()
		
	def remove_tag(self, tag):
		self.remove(self.tags[tag])
		self.tags.remove(self.tags[tag])
		
	def clear(self):
		for child in self.get_children():
			self.remove(child)
		self.tags = {}
		self.resize(1, 4)
		self.next_place = (0, 0)
		
	def get_tags(self):
		''' return the marked tags as list'''
		return self.tags.keys() or None
	
	def get_string(self):
		''' return the marked tags as list'''
		return string.join(self.tags.keys(), ',')
	
