#!/usr/bin/env python
# encoding=utf-8

import pickle
import string
import tools

class Tags:
	''' The tags management '''
	def __init__(self, app):
		self._app = app
		self.__tags = None
		#self.tagfile = self._app.Settings['tagfile']
		
	def store(self):
		dumpf = open(self._app.Settings['tagfile'] , "w")		
		pickle.dump(self.__tags, dumpf)
		dumpf.close()
	   
	def load(self):
		try:
			dumpf = open(self._app.Settings['tagfile'] , "r")	  
			self.__tags = pickle.load(dumpf)
			dumpf.close()
			self.__tags.sort(key=str.lower)
			return self.__tags
		except:
			return None
		return None
	
	def add(self, tagname):
		tagname = string.strip(tagname)
		if self.__tags == None:
			self.__tags = []		
		if tools.validate_tag(tagname) == False or tagname in self.__tags:
			return False
		self.__tags.append(tagname)
		self.__tags.sort(key=str.lower)
			
	def remove(self, tagname):
		if self.__tags == None:
			return False
		else:
			self.__tags.remove(tagname)
			self.__tags.sort(key=str.lower)
			self._app.Bookmarks.remove_tag_from_all(tagname)
			
	def get_tags(self):
		return self.__tags